local function ConvertOpticality(num)
	if num == nil then num = 50 end
	return (num)/100
end

local function SimpleMapPlusCommands(msg, editbox)
	if msg == '' then
		onoff = 'off'
		if SimpleMapPlusEnabled then onoff = 'on' end
		print('SimpleMapPlus is '..onoff..'.')
		print('SimpleMapPlus map fade is set to '..SimpleMapPlusFade..'%')
		print('SimpleMapPlus map focus is set to '..SimpleMapPlusFocus..'%')
	elseif msg == 'help' or  msg == '?' then
		print('SimpleMapPlus Usage:')
		print('/smpfade: List current settings')
		print('/smpfade on/off: Turn auto-fading on/off the plugin')
		print('/smpfade 1 to 100: Percent visible when moving and mouse is hovering over the map')
		print('/smpfade -0 to -100: Percent visible when moving and mouse is NOT hovering over the map')
		print('Valid arguments are on/off and positive or negative number between 0-100.')
	elseif msg == 'off' then
		PlayerMovementFrameFader.AddDeferredFrame(WorldMapFrame, 1, 1, 0)
		SimpleMapPlusEnabled = false
		print('SimpleMapPlus fade has been turned off.')
	elseif msg == 'on' then
		PlayerMovementFrameFader.AddDeferredFrame(WorldMapFrame, ConvertOpticality(SimpleMapPlusFade), 1, 0)
		SimpleMapPlusEnabled = true
		print('SimpleMapPlus fade has been turned on.')
	elseif tonumber(msg) >= 1 and tonumber(msg) <= 100 then 
		SimpleMapPlusFocus = tonumber(msg)
		if WorldMapFrame:IsVisible() and MouseIsOver(WorldMapFrame) then 
			PlayerMovementFrameFader.AddFrame(WorldMapFrame, ConvertOpticality(SimpleMapPlusFocus), 1, 0)
		end
		print('Map focus is set to '..SimpleMapPlusFocus..'%.')
	elseif tonumber(msg) <= 0 and tonumber(msg) >= -100 then 
		SimpleMapPlusFade = tonumber(msg)-(tonumber(msg)*2)
		if not MouseIsOver(WorldMapFrame) then 
			PlayerMovementFrameFader.AddFrame(WorldMapFrame, ConvertOpticality(SimpleMapPlusFade), 1, 0)
		end
		print('Map fade is set to '..SimpleMapPlusFade..'%.')
	else
		print('Valid arguments are on/off and positive or negative number between 0-100.')
		print('Type /smpfade help for usage guidance.')
	end
end

local EventFrame = CreateFrame("Frame")

EventFrame:RegisterEvent("PLAYER_LOGIN")

local lastFocus = false

EventFrame:SetScript("OnUpdate", function(self)
	if not SimpleMapPlusEnabled then return end
	local curFocus = WorldMapFrame:IsVisible() and MouseIsOver(WorldMapFrame)
	if curFocus == lastFocusthen then return else lastFocus = curFocus end
	if curFocus then
		PlayerMovementFrameFader.AddFrame(WorldMapFrame, ConvertOpticality(SimpleMapPlusFocus), 1, 0)
	else 
		PlayerMovementFrameFader.AddFrame(WorldMapFrame, ConvertOpticality(SimpleMapPlusFade), 1, 0)
	end
end)

EventFrame:SetScript("OnEvent", function(self,event,...)
	if SimpleMapPlusEnabled == true then
		PlayerMovementFrameFader.AddDeferredFrame(WorldMapFrame, ConvertOpticality(SimpleMapPlusFade), 1, 0)
	elseif SimpleMapPlusEnabled == false then
		PlayerMovementFrameFader.AddDeferredFrame(WorldMapFrame, ConvertOpticality(SimpleMapPlusFade), 1, 0)
	else
		SimpleMapPlusEnabled = true
		SimpleMapPlusFade = 25
		SimpleMapPlusFocus = 75
		PlayerMovementFrameFader.AddDeferredFrame(WorldMapFrame, ConvertOpticality(SimpleMapPlusFade), 1, 0)
	end
end)

WorldMapFrame:SetScale(0.8)
WorldMapFrame.BlackoutFrame.Blackout:SetAlpha(0)
WorldMapFrame.BlackoutFrame:EnableMouse(false)

WorldMapFrame:SetMovable(true)
WorldMapFrame:EnableMouse(true)
WorldMapFrame:RegisterForDrag("LeftButton")
WorldMapFrame:SetScript("OnDragStart", WorldMapFrame.StartMoving)
WorldMapFrame:SetScript("OnDragStop", WorldMapFrame.StopMovingOrSizing)

WorldMapFrame.ScrollContainer.GetCursorPosition = function(f)
	local x,y = MapCanvasScrollControllerMixin.GetCursorPosition(f);
	local s = WorldMapFrame:GetScale();
	return x/s, y/s;
end

SlashCmdList["SMPFADE"] = SimpleMapPlusCommands

SLASH_SMPFADE1 = '/smpfade'